// Code generated by protoc-gen-go. DO NOT EDIT.
// source: google/devtools/cloudtrace/v2/tracing.proto

package cloudtrace

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import _ "google.golang.org/genproto/googleapis/api/annotations"
import google_protobuf4 "github.com/golang/protobuf/ptypes/empty"
import _ "github.com/golang/protobuf/ptypes/timestamp"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// The request message for the `BatchWriteSpans` method.
type BatchWriteSpansRequest struct {
	// Required. Name of the project where the spans belong. The format is
	// `projects/PROJECT_ID`.
	Name string `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	// A collection of spans.
	Spans []*Span `protobuf:"bytes,2,rep,name=spans" json:"spans,omitempty"`
}

func (m *BatchWriteSpansRequest) Reset()                    { *m = BatchWriteSpansRequest{} }
func (m *BatchWriteSpansRequest) String() string            { return proto.CompactTextString(m) }
func (*BatchWriteSpansRequest) ProtoMessage()               {}
func (*BatchWriteSpansRequest) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{0} }

func (m *BatchWriteSpansRequest) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *BatchWriteSpansRequest) GetSpans() []*Span {
	if m != nil {
		return m.Spans
	}
	return nil
}

func init() {
	proto.RegisterType((*BatchWriteSpansRequest)(nil), "google.devtools.cloudtrace.v2.BatchWriteSpansRequest")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for TraceService service

type TraceServiceClient interface {
	// Sends new spans to Stackdriver Trace or updates existing traces. If the
	// name of a trace that you send matches that of an existing trace, new spans
	// are added to the existing trace. Attempt to update existing spans results
	// undefined behavior. If the name does not match, a new trace is created
	// with given set of spans.
	BatchWriteSpans(ctx context.Context, in *BatchWriteSpansRequest, opts ...grpc.CallOption) (*google_protobuf4.Empty, error)
	// Creates a new Span.
	CreateSpan(ctx context.Context, in *Span, opts ...grpc.CallOption) (*Span, error)
}

type traceServiceClient struct {
	cc *grpc.ClientConn
}

func NewTraceServiceClient(cc *grpc.ClientConn) TraceServiceClient {
	return &traceServiceClient{cc}
}

func (c *traceServiceClient) BatchWriteSpans(ctx context.Context, in *BatchWriteSpansRequest, opts ...grpc.CallOption) (*google_protobuf4.Empty, error) {
	out := new(google_protobuf4.Empty)
	err := grpc.Invoke(ctx, "/google.devtools.cloudtrace.v2.TraceService/BatchWriteSpans", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *traceServiceClient) CreateSpan(ctx context.Context, in *Span, opts ...grpc.CallOption) (*Span, error) {
	out := new(Span)
	err := grpc.Invoke(ctx, "/google.devtools.cloudtrace.v2.TraceService/CreateSpan", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for TraceService service

type TraceServiceServer interface {
	// Sends new spans to Stackdriver Trace or updates existing traces. If the
	// name of a trace that you send matches that of an existing trace, new spans
	// are added to the existing trace. Attempt to update existing spans results
	// undefined behavior. If the name does not match, a new trace is created
	// with given set of spans.
	BatchWriteSpans(context.Context, *BatchWriteSpansRequest) (*google_protobuf4.Empty, error)
	// Creates a new Span.
	CreateSpan(context.Context, *Span) (*Span, error)
}

func RegisterTraceServiceServer(s *grpc.Server, srv TraceServiceServer) {
	s.RegisterService(&_TraceService_serviceDesc, srv)
}

func _TraceService_BatchWriteSpans_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BatchWriteSpansRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TraceServiceServer).BatchWriteSpans(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/google.devtools.cloudtrace.v2.TraceService/BatchWriteSpans",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TraceServiceServer).BatchWriteSpans(ctx, req.(*BatchWriteSpansRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TraceService_CreateSpan_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Span)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TraceServiceServer).CreateSpan(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/google.devtools.cloudtrace.v2.TraceService/CreateSpan",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TraceServiceServer).CreateSpan(ctx, req.(*Span))
	}
	return interceptor(ctx, in, info, handler)
}

var _TraceService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "google.devtools.cloudtrace.v2.TraceService",
	HandlerType: (*TraceServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "BatchWriteSpans",
			Handler:    _TraceService_BatchWriteSpans_Handler,
		},
		{
			MethodName: "CreateSpan",
			Handler:    _TraceService_CreateSpan_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "google/devtools/cloudtrace/v2/tracing.proto",
}

func init() { proto.RegisterFile("google/devtools/cloudtrace/v2/tracing.proto", fileDescriptor1) }

var fileDescriptor1 = []byte{
	// 393 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x92, 0x4f, 0x6b, 0xdb, 0x30,
	0x18, 0xc6, 0x91, 0xf7, 0x07, 0xa6, 0x0d, 0x06, 0x82, 0x85, 0xe0, 0x6d, 0x2c, 0xf3, 0x60, 0xcb,
	0x9c, 0x21, 0x31, 0x8f, 0x1d, 0x96, 0xb1, 0x4b, 0xc2, 0xc8, 0x35, 0x24, 0x63, 0x85, 0xde, 0x14,
	0x47, 0x55, 0x55, 0x6c, 0xc9, 0xb5, 0x14, 0x43, 0x29, 0xb9, 0xf4, 0xd6, 0x73, 0xf3, 0x29, 0x7a,
	0xeb, 0x67, 0xe9, 0x57, 0xe8, 0x07, 0x29, 0x92, 0x9c, 0x06, 0x42, 0x9a, 0xe4, 0x26, 0xf9, 0xfd,
	0xbd, 0xcf, 0xfb, 0x3e, 0x8f, 0x05, 0x3b, 0x5c, 0x29, 0x9e, 0x31, 0x32, 0x65, 0x95, 0x51, 0x2a,
	0xd3, 0x24, 0xcd, 0xd4, 0x6c, 0x6a, 0x4a, 0x9a, 0x32, 0x52, 0x25, 0xc4, 0x1e, 0x84, 0xe4, 0xb8,
	0x28, 0x95, 0x51, 0xe8, 0xbd, 0x87, 0xf1, 0x12, 0xc6, 0x2b, 0x18, 0x57, 0x49, 0xf8, 0xae, 0xd6,
	0xa2, 0x85, 0x20, 0x54, 0x4a, 0x65, 0xa8, 0x11, 0x4a, 0x6a, 0xdf, 0x1c, 0x7e, 0xdd, 0x3d, 0x89,
	0xd5, 0xe8, 0xdb, 0x1a, 0x75, 0xb7, 0xc9, 0xec, 0x88, 0xb0, 0xbc, 0x30, 0x67, 0x75, 0xf1, 0xc3,
	0x7a, 0xd1, 0x88, 0x9c, 0x69, 0x43, 0xf3, 0xc2, 0x03, 0x11, 0x87, 0x8d, 0x1e, 0x35, 0xe9, 0xf1,
	0x41, 0x29, 0x0c, 0x1b, 0x17, 0x54, 0xea, 0x11, 0x3b, 0x9d, 0x31, 0x6d, 0x10, 0x82, 0x4f, 0x25,
	0xcd, 0x59, 0x13, 0xb4, 0x40, 0xfb, 0xc5, 0xc8, 0x9d, 0xd1, 0x2f, 0xf8, 0x4c, 0x5b, 0xa6, 0x19,
	0xb4, 0x9e, 0xb4, 0x5f, 0x26, 0x9f, 0xf0, 0x56, 0x8f, 0xd8, 0xea, 0x8d, 0x7c, 0x47, 0x72, 0x13,
	0xc0, 0x57, 0xff, 0x6c, 0x61, 0xcc, 0xca, 0x4a, 0xa4, 0x0c, 0x2d, 0x00, 0x7c, 0xbd, 0x36, 0x1a,
	0xfd, 0xdc, 0x21, 0xb8, 0x79, 0xd5, 0xb0, 0xb1, 0x6c, 0x5b, 0xda, 0xc4, 0x7f, 0x6d, 0x06, 0x51,
	0x72, 0x71, 0x7b, 0x77, 0x15, 0x7c, 0x8b, 0xbe, 0xd8, 0xcc, 0xce, 0xad, 0x83, 0x3f, 0x45, 0xa9,
	0x4e, 0x58, 0x6a, 0x34, 0x89, 0xe7, 0x3e, 0x45, 0xdd, 0x9d, 0x3c, 0x88, 0x76, 0x41, 0x8c, 0x2e,
	0x01, 0x84, 0xfd, 0x92, 0x51, 0x3f, 0x02, 0xed, 0x63, 0x31, 0xdc, 0x07, 0x8a, 0xbe, 0xbb, 0x65,
	0x3a, 0xe1, 0xe7, 0x4d, 0xcb, 0xd4, 0xbb, 0x90, 0x98, 0xb8, 0xb4, 0x48, 0x3c, 0xef, 0x82, 0xb8,
	0xb7, 0x00, 0xf0, 0x63, 0xaa, 0xf2, 0xed, 0xea, 0x3d, 0x17, 0xab, 0x90, 0x7c, 0x68, 0xcd, 0x0f,
	0xc1, 0xe1, 0xa0, 0xc6, 0xb9, 0xca, 0xa8, 0xe4, 0x58, 0x95, 0x9c, 0x70, 0x26, 0x5d, 0x34, 0xc4,
	0x97, 0x68, 0x21, 0xf4, 0x23, 0x4f, 0xeb, 0xf7, 0xea, 0x76, 0x1d, 0xbc, 0x19, 0x78, 0xa5, 0xbe,
	0xfd, 0x86, 0xdd, 0xdf, 0xc3, 0xff, 0x93, 0xc9, 0x73, 0xa7, 0xf5, 0xe3, 0x3e, 0x00, 0x00, 0xff,
	0xff, 0x3b, 0x70, 0x0d, 0x09, 0x0f, 0x03, 0x00, 0x00,
}
